#include "B4RDefines.h"

namespace B4R
{

    void B4RLoRaClass::Initialize()
    {
       rcs = new (backend) LoRaClass();
    };

    void B4RLoRaClass::looper(void* b) 
    {
       B4RLoRaClass* me = (B4RLoRaClass*)b;
       int c = me->rcs->parsePacket();
       if (c != 0) { 
          me->DataAvailableSub();}
    };

    void B4RLoRaClass::begin(SubVoidVoid DataAvailableSub, long frequency)
    {
       this->DataAvailableSub = DataAvailableSub; 
       FunctionUnion fu; 
       fu.PollerFunction = looper;
       pnode.functionUnion = fu;
       pnode.tag = this; 
       if (pnode.next == NULL) 
          pollers.add(&pnode); 
       rcs->begin(frequency);
    };

    void B4RLoRaClass::end()
    {
       rcs->end();
    };

    int B4RLoRaClass::beginPacket(int implicitHeader)
    {
       return rcs->beginPacket(implicitHeader);
    };

    int B4RLoRaClass::endPacket(bool async)
    {
       return rcs->endPacket(async);
    };

    int B4RLoRaClass::packetRssi()
    {
       return rcs->packetRssi();
    };

    double B4RLoRaClass::packetSnr()
    {
       return rcs->packetSnr();
    };

    long B4RLoRaClass::packetFrequencyError()
    {
       return rcs->packetFrequencyError();
    };

    uint B4RLoRaClass::write(byte byte)
    {
       return rcs->write(byte);
    };

    uint B4RLoRaClass::write1(ArrayByte* buffer, uint size)
    {
       return rcs->write((Byte*)buffer->data, size);
    };

    int B4RLoRaClass::available()
    {
       return rcs->available();
    };

    int B4RLoRaClass::read()
    {
       return rcs->read();
    };

    int B4RLoRaClass::peek()
    {
       return rcs->peek();
    };

    void B4RLoRaClass::flush()
    {
       rcs->flush();
    };

    void B4RLoRaClass::idle()
    {
       rcs->idle();
    };

    void B4RLoRaClass::sleep()
    {
       rcs->sleep();
    };

    void B4RLoRaClass::setTxPower(int level, int outputPin)
    {
       rcs->setTxPower(level, outputPin);
    };

    void B4RLoRaClass::setFrequency(long frequency)
    {
       rcs->setFrequency(frequency);
    };

    void B4RLoRaClass::setSpreadingFactor(int sf)
    {
       rcs->setSpreadingFactor(sf);
    };

    void B4RLoRaClass::setSignalBandwidth(long sbw)
    {
       rcs->setSignalBandwidth(sbw);
    };

    void B4RLoRaClass::setCodingRate4(int denominator)
    {
       rcs->setCodingRate4(denominator);
    };

    void B4RLoRaClass::setPreambleLength(long length)
    {
       rcs->setPreambleLength(length);
    };

    void B4RLoRaClass::setSyncWord(int sw)
    {
       rcs->setSyncWord(sw);
    };

    void B4RLoRaClass::enableCrc()
    {
       rcs->enableCrc();
    };

    void B4RLoRaClass::disableCrc()
    {
       rcs->disableCrc();
    };

    void B4RLoRaClass::enableInvertIQ()
    {
       rcs->enableInvertIQ();
    };

    void B4RLoRaClass::disableInvertIQ()
    {
       rcs->disableInvertIQ();
    };
 
    void B4RLoRaClass::setOCP(byte mA)
    {
       rcs->setOCP(mA);
    };

    void B4RLoRaClass::crc()
    {
       rcs->enableCrc();
    };

    void B4RLoRaClass::noCrc()
    {
       rcs->disableCrc();
    };

    byte B4RLoRaClass::random()
    {
       return rcs->random();
    };

    void B4RLoRaClass::setPins(int ss, int reset, int dio0)
    {
       rcs->setPins(ss, reset, dio0);
    };

    void B4RLoRaClass::setSPIFrequency(ulong frequency)
    {
       rcs->setSPIFrequency(frequency);
    };

    ArrayByte* B4RLoRaClass::dumpRegisters()
    {
       byte* raw = rcs->dumpRegisters();
       unsigned int len = 128; //raw.size(); 
       ArrayByte* arr = CreateStackMemoryObject(ArrayByte);
        arr->data = (StackMemory::buffer + StackMemory::cp);
        for (int i = 0;i < len; i++) {
            StackMemory::buffer[StackMemory::cp++] = raw[i];        
        }
        arr->length=len;
        return arr;
    };

}
