#pragma once
#include "B4RDefines.h"
#include "LoRa.h"

    //~shortname:LoRa
    //~Event: DataAvailable()
    //~Version: 1.0 
    //~Author - 
    //Libray from Arduino

namespace B4R {
    class B4RLoRaClass
    {
        private:
            uint8_t backend[sizeof(LoRaClass)];
            LoRaClass* rcs;
            PollerNode pnode;
            SubVoidVoid DataAvailableSub;
            static void looper(void* b);
        public: 
            void Initialize();
            void begin(SubVoidVoid DataAvailableSub, long frequency);
            void end();
            int beginPacket(int implicitHeader);
            int endPacket(bool async);
            int packetRssi();
            double packetSnr();
            long packetFrequencyError();
            uint write(byte byte);
            uint write1(ArrayByte* buffer, uint size);
            int available();
            int read();
            int peek();
            void flush();
            void idle();
            void sleep();
            void setTxPower(int level, int outputPin);
            void setFrequency(long frequency);
            void setSpreadingFactor(int sf);
            void setSignalBandwidth(long sbw);
            void setCodingRate4(int denominator);
            void setPreambleLength(long length);
            void setSyncWord(int sw);
            void enableCrc();
            void disableCrc();
            void enableInvertIQ();
            void disableInvertIQ();
            void setOCP(byte mA);
            void crc();
            void noCrc();
            byte random();
            void setPins(int ss, int reset, int dio0);
            void setSPIFrequency(ulong frequency);
            ArrayByte* dumpRegisters();
    };
}
